xref: /freebsd/tests/sys/acl/03.sh (revision c1d255d3)
1#!/bin/sh
2#
3# Copyright (c) 2008, 2009 Edward Tomasz Napierała <trasz@FreeBSD.org>
4#
5# Redistribution and use in source and binary forms, with or without
6# modification, are permitted provided that the following conditions
7# are met:
8# 1. Redistributions of source code must retain the above copyright
9#    notice, this list of conditions and the following disclaimer.
10# 2. Redistributions in binary form must reproduce the above copyright
11#    notice, this list of conditions and the following disclaimer in the
12#    documentation and/or other materials provided with the distribution.
13#
14# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
15# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
16# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
17# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
18# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
19# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
20# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
21# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
22# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
23# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
24# SUCH DAMAGE.
25#
26# $FreeBSD$
27#
28
29# This is a wrapper script to run tools-crossfs.test between UFS without
30# ACLs, UFS with POSIX.1e ACLs, and ZFS with NFSv4 ACLs.
31#
32# WARNING: It uses hardcoded ZFS pool name "acltools"
33#
34# Output should be obvious.
35
36if ! sysctl vfs.zfs.version.spa >/dev/null 2>&1; then
37	echo "1..0 # SKIP system doesn't have ZFS loaded"
38	exit 0
39fi
40if [ $(id -u) -ne 0 ]; then
41	echo "1..0 # SKIP you must be root"
42	exit 0
43fi
44
45echo "1..5"
46
47TESTDIR=$(dirname $(realpath $0))
48MNTROOT=`mktemp -dt acltools`
49
50# Set up the test filesystems.
51MD1=`mdconfig -at swap -s 64m`
52MNT1=$MNTROOT/nfs4
53mkdir $MNT1
54zpool create -m $MNT1 acltools /dev/$MD1
55if [ $? -ne 0 ]; then
56	echo "not ok 1 - 'zpool create' failed."
57	echo 'Bail out!'
58	exit 1
59fi
60
61echo "ok 1"
62
63MD2=`mdconfig -at swap -s 10m`
64MNT2=$MNTROOT/posix
65mkdir $MNT2
66newfs /dev/$MD2 > /dev/null
67mount -o acls /dev/$MD2 $MNT2
68if [ $? -ne 0 ]; then
69	echo "not ok 2 - mount failed."
70	echo 'Bail out!'
71	exit 1
72fi
73
74echo "ok 2"
75
76MD3=`mdconfig -at swap -s 10m`
77MNT3=$MNTROOT/none
78mkdir $MNT3
79newfs /dev/$MD3 > /dev/null
80mount /dev/$MD3 $MNT3
81if [ $? -ne 0 ]; then
82	echo "not ok 3 - mount failed."
83	echo 'Bail out!'
84	exit 1
85fi
86
87echo "ok 3"
88
89cd $MNTROOT
90
91perl $TESTDIR/run $TESTDIR/tools-crossfs.test >&2
92
93if [ $? -eq 0 ]; then
94	echo "ok 4"
95else
96	echo "not ok 4"
97fi
98
99cd /
100
101umount -f $MNT3
102rmdir $MNT3
103mdconfig -du $MD3
104
105umount -f $MNT2
106rmdir $MNT2
107mdconfig -du $MD2
108
109zpool destroy -f acltools
110rmdir $MNT1
111mdconfig -du $MD1
112
113rmdir $MNTROOT
114
115echo "ok 5"
116
117